
#Region - Chilkat.au3 - Header
; #INDEX# ========================================================================
; Title .........: Chilkat.au3
; AutoIt Version : 3.3.10.2++
; Language ......: English
; Description ...: A collection of Function for use with Chilkat component
; Author ........: mLipok
; Modified ......:
; URL ...........: https://www.chilkatsoft.com/refdoc/activex.asp
; Date ..........: 2017/02/01
; Version .......: 0.1.1 BETA - Work in progress
; ================================================================================

#cs
	2017/02/01
	.	First official version - mLipok

#ce
#EndRegion - Chilkat.au3 - Header

#Region - Chilkat.au3 - Options
#AutoIt3Wrapper_Au3Check_Parameters=-d -w 1 -w 2 -w 3 -w- 4 -w 5 -w 6 -w 7
;~ #AutoIt3Wrapper_Run_Debug_Mode=Y
#Tidy_Parameters=/sort_funcs /reel
#EndRegion - Chilkat.au3 - Options

#Region - Chilkat.au3 - Include
#include-once
#include <AutoItConstants.au3>
#include <StringConstants.au3>
#include "ChilkatConstants.au3"
#EndRegion - Chilkat.au3 - Include

OnAutoItExitRegister(_Chilkat_ShutDown) ; in case the script exit without calling _Chilkat_ShutDown()

#Region - Chilkat.au3 - Function - INIT

Func _Chilkat_CSV_ObjCreate()
	If $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then _
			Return __ErrorLog_Chilkat('DLL Version is not set.') & _
			SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)

	Local $oObject = ObjCreate($CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_CSV][$CHILKATOBJ_ID_CLSID], $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_CSV][$CHILKATOBJ_ID_IID], $__g_hDll_CHILKAT)
	If @error Then _
			Return __ErrorLog_Chilkat('ObjCreate: ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_CSV][$CHILKATOBJ_ID_PROGID]) & _
			SetError($CHILKAT_ERR_OBJECTCREATE, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	Return $oObject
EndFunc   ;==>_Chilkat_CSV_ObjCreate

Func _Chilkat_DllVersion($iVersion = Default)
	If $iVersion = Default And $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then
		Return __ErrorLog_Chilkat('DLL Version is not set.') & _
				SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	ElseIf $iVersion = Default Then
		Return SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $__g_iChilkat_DLLVersion)
	ElseIf Not IsInt($iVersion) Then
		Return __ErrorLog_Chilkat('Invalid Parameter Type - Version should be Integer') & _
				SetError($CHILKAT_ERR_INVALIDPARAMETERTYPE, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)
	ElseIf $iVersion < 0 Or $iVersion > $CHILKATOBJ_VERSION_COUNTER - 1 Then
		Return __ErrorLog_Chilkat('Invalid Parameter Value - for Version number look for $CHILKATOBJ_VERSION_* ') & _
				SetError($CHILKAT_ERR_INVALIDPARAMETERVALUE, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)
	EndIf

	$__g_iChilkat_DLLVersion = $iVersion
	Return SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_SUCCESS)
EndFunc   ;==>_Chilkat_DllVersion

Func _Chilkat_GLOBAL_ObjCreate()
	If $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then _
			Return __ErrorLog_Chilkat('DLL Version is not set.') & _
			SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)

	Local $oObject = ObjCreate($CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_GLOBAL][$CHILKATOBJ_ID_CLSID], $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_GLOBAL][$CHILKATOBJ_ID_IID], $__g_hDll_CHILKAT)
	If @error Then _
			Return __ErrorLog_Chilkat('ObjCreate: ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_GLOBAL][$CHILKATOBJ_ID_PROGID]) & _
			SetError($CHILKAT_ERR_OBJECTCREATE, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	Return $oObject
EndFunc   ;==>_Chilkat_GLOBAL_ObjCreate

Func _Chilkat_GLOBAL_UnlockBundle(ByRef $oGLOBAL, $sUnlockCode)
	Local $iSuccess = $oGLOBAL.UnlockBundle($sUnlockCode)
	If $iSuccess <> 1 Then _
			Return __ErrorLog_Chilkat('$oGLOBAL.UnlockBundle() ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_GLOBAL][$CHILKATOBJ_ID_PROGID] & @CRLF & $oGLOBAL.LastErrorText) & _
			SetError($CHILKAT_ERR_UNLOCK, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)

	Return SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_SUCCESS)
EndFunc   ;==>_Chilkat_GLOBAL_UnlockBundle

Func _Chilkat_JSON_ObjCreate()
	If $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then _
			Return __ErrorLog_Chilkat('DLL Version is not set.') & _
			SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)

	Local $oObject = ObjCreate($CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_JSON][$CHILKATOBJ_ID_CLSID], $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_JSON][$CHILKATOBJ_ID_IID], $__g_hDll_CHILKAT)
	If @error Then _
			Return __ErrorLog_Chilkat('ObjCreate: ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_JSON][$CHILKATOBJ_ID_PROGID]) & _
			SetError($CHILKAT_ERR_OBJECTCREATE, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	Return $oObject
EndFunc   ;==>_Chilkat_JSON_ObjCreate

Func _Chilkat_ShutDown()
	DllClose($__g_hDll_CHILKAT)
EndFunc   ;==>_Chilkat_ShutDown

Func _Chilkat_SSHTunel_ObjCreate()
	If $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then _
			Return __ErrorLog_Chilkat('DLL Version is not set.') & _
			SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)

	Local $oObject = ObjCreate($CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_SSHTUNEL][$CHILKATOBJ_ID_CLSID], $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_SSHTUNEL][$CHILKATOBJ_ID_IID], $__g_hDll_CHILKAT)
	If @error Then _
			Return __ErrorLog_Chilkat('ObjCreate: ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_SSHTUNEL][$CHILKATOBJ_ID_PROGID]) & _
			SetError($CHILKAT_ERR_OBJECTCREATE, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	Return $oObject
EndFunc   ;==>_Chilkat_SSHTunel_ObjCreate

Func _Chilkat_StartUp($sDLL_FileFullPath )
	If Not FileExists($sDLL_FileFullPath) Then _
			Return __ErrorLog_Chilkat('DLL File not exist:' & $sDLL_FileFullPath) & _
			SetError($CHILKAT_ERR_FILENOTEXIST, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)
	$__g_hDll_CHILKAT = DllOpen($sDLL_FileFullPath)
	If @error then _
			Return __ErrorLog_Chilkat('DLL open error.' & $sDLL_FileFullPath) & _
			SetError($CHILKAT_ERR_FILENOTEXIST, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)

	Return SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_SUCCESS)
EndFunc   ;==>_Chilkat_StartUp

Func _Chilkat_UnlockComponent($oChilkat, $sUnlockCode)
	__Chilkat_IsValidObject($oChilkat)
	If @error Then Return SetError(@error, @extended, $CHILKAT_RET_FAILURE)

	Local $iSuccess = $oChilkat.UnlockComponent($sUnlockCode)
	If $iSuccess <> 1 Then _
			Return __ErrorLog_Chilkat('$oChilkat.UnlockComponent() ' & ObjName($oChilkat, $OBJ_PROGID) & @CRLF & $oChilkat.LastErrorText) & _
			SetError($CHILKAT_ERR_UNLOCK, $CHILKAT_EXT_PARAM2, $CHILKAT_RET_FAILURE)

	Return SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_SUCCESS)

	#CS
		http://cknotes.com/unlockcomponent-returns-false0/
		https://www.chilkatsoft.com/p/p_402.asp
		http://cknotes.com/unlockcomponent-lasterrortext-shows-exact-string-passed-to-it/
		http://cknotes.com/verify-unlockcomponent-success-w-permanent-unlock-code/
	#CE
EndFunc   ;==>_Chilkat_UnlockComponent

Func _Chilkat_XML_ObjCreate()
	If $__g_iChilkat_DLLVersion = $CHILKAT_RET_FAILURE Then _
			Return __ErrorLog_Chilkat('DLL Version is not set.') & _
			SetError($CHILKAT_ERR_DLLVERSIONNOTSET, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)

	Local $oObject = ObjCreate($CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_XML][$CHILKATOBJ_ID_CLSID], $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_XML][$CHILKATOBJ_ID_IID], $__g_hDll_CHILKAT)
	If @error Then _
			Return __ErrorLog_Chilkat('ObjCreate: ' & $CHILKATOBJ_API[$__g_iChilkat_DLLVersion][$CHILKATOBJ_NAME_XML][$CHILKATOBJ_ID_PROGID]) & _
			SetError($CHILKAT_ERR_OBJECTCREATE, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_FAILURE)
	Return $oObject
EndFunc   ;==>_Chilkat_XML_ObjCreate
#EndRegion - Chilkat.au3 - Function - INIT

#Region - Chilkat.au3 - Function - Misc

Func __Chilkat_IsValidObject($oObject)
	If Not IsObj($oObject) Then _
			Return __ErrorLog_Chilkat('IsNotObject:   VarGetType = ' & VarGetType($oObject)) & _
			SetError($CHILKAT_ERR_ISNOTOBJ, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)

	If StringRegExp(ObjName($oObject, $OBJ_PROGID), '(?i)(Chilkat_\d+_\d+_\d+\..+)', 1) Then _
			Return __ErrorLog_Chilkat('IsNotValid Chilkat Object: ' & ObjName($oObject, $OBJ_PROGID)) & _
			SetError($CHILKAT_ERR_ISNOTCHILKAT, $CHILKAT_EXT_PARAM1, $CHILKAT_RET_FAILURE)

	SetError($CHILKAT_ERR_SUCCESS, $CHILKAT_EXT_DEFAULT, $CHILKAT_RET_SUCCESS)
EndFunc   ;==>__Chilkat_IsValidObject

Func __ErrorLog_Chilkat($sText, $iError = @error, $iExtended = @extended)
	Local $fnFunction = _ErrorLog_ChilkatWrapper()
	If IsFunc($fnFunction) Then $fnFunction("!" & ' @error=' & $iError & ' @extended=' & $iExtended & ' : ' & $sText & @CRLF)
	Return SetError($iError, $iExtended)
EndFunc   ;==>__ErrorLog_Chilkat

Func _Chilkat_GetVersion()
	Local $oGLOBAL = _Chilkat_GLOBAL_ObjCreate()
	If @error Then Return SetError(@error, @extended, $CHILKAT_RET_FAILURE)

	Return $oGLOBAL.Version
EndFunc   ;==>_Chilkat_GetVersion

Func _ErrorLog_ChilkatWrapper($fnFunction = Default)
	Local Static $fnFunction_static = Null
	If $fnFunction = Default Then Return $fnFunction_static
	If Not IsFunc($fnFunction) Then Return SetError(1)

	$fnFunction_static = $fnFunction
	Return $fnFunction_static
EndFunc   ;==>_ErrorLog_ChilkatWrapper
#EndRegion - Chilkat.au3 - Function - Misc

